; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
    .nolist
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\comctl32.inc
      include \masm32\include\dialogs.inc
      include \masm32\include\debug.inc
      include \masm32\macros\macros.asm     ; the macro file
    .list

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\comctl32.lib
      includelib \masm32\lib\debug.lib

      include ..\common\common.inc
      include toolbar1.inc
      
      
    ; ----------------------------------------
    ; prototypes for local procedures go here
    ; ----------------------------------------

      .const
        szToolbarClass      BYTE        "ToolbarWindow32",0
        szNull              BYTE        0
        
      .data
        piPlugin            PLUGININFO  <0, STARTUP_AUTOMATIC, 0, OFFSET Unload, 16 DUP (0)>
        
      .data?
        hPluginID           DWORD       ?
        hInstance           DWORD       ?
        frmMain             DWORD       ?
        hToolbar            DWORD       ?
        hOldProc            DWORD       ?

      .code

      include TOOLBAR.ASM

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 
    .if reason == DLL_PROCESS_ATTACH
      push instance
      pop hInstance
      mov eax, TRUE
    .elseif reason == DLL_PROCESS_DETACH
    .elseif reason == DLL_THREAD_ATTACH
    .elseif reason == DLL_THREAD_DETACH
    .endif

    ret
LibMain endp

; 
TB_Proc PROTO :DWORD, :DWORD, :DWORD, :DWORD

TB_Proc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    invoke  CallWindowProc, hOldProc, hWnd, uMsg, wParam, lParam
  ; Subclassed code in here

    ret
TB_Proc ENDP

TB_Command PROC USES ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    LOCAL   hMemDC:DWORD
    LOCAL   hBitmap:DWORD
    LOCAL   BMI:BITMAPINFO
    LOCAL   BMP:BITMAP
    
    .if     (wParam == 50)
        IF DEBUG
            PrintText "Creating New Child Window"
            PrintLine
        ENDIF
            ; Create a new window when the New button is clicked
        invoke  PostMessage, NULL, PLUGIN_CHILDMSG_NEW, NULL, 0
    .elseif (wParam == 51)
        IF DEBUG
            PrintText "Creating New Child Window and loading sample"
            PrintLine
        ENDIF
            ; Loads toolbar.bmp stored in toolbar1.dll into memory and into a new window
        xor     ebx, ebx
        
        invoke  PostMessage, NULL, PLUGIN_CHILDMSG_NEW, NULL, ebx   ; ebx contains pointer to OPENCHILDWINDOW structure
        PrintDec wParam, "TB_Command"
    .endif
    ret
TB_Command ENDP


Init PROC USES ebx edi dwData:DWORD
    call    InitCommonControls
    
    mov     eax, dwData
    mov     frmMain, eax
    invoke  Do_ToolBar, eax
    mov     hToolbar, eax
    IF DEBUG
        PrintHex hToolbar, "Toolbar handle"
        PrintLine
    ENDIF
    
        ; Sets up a subclassed toolbar so this plugin can handle messages rather than the kernel.
    invoke  SetWindowLong, hToolbar, GWL_WNDPROC, OFFSET TB_Proc
    mov     hOldProc, eax
    
        ; Informs the ui plugin that there is a size restriction
    mov     ebx, MAlloc(SIZEOF RECT)
    ASSUME  ebx:PTR RECT
    
    invoke  GetWindowRect, hToolbar, ebx
    mov     [ebx].left, 0
    mov     [ebx].right, 0
    mov     edx, [ebx].bottom
    sub     edx, [ebx].top
    mov     [ebx].top, edx
    mov     [ebx].bottom, 0
    
    invoke  PostMessage, NULL, PLUGIN_WINDOWMSG_RESTRICTSIZE, 0, ebx
    
        ; Informs the ui plugin that we want to receive WM_COMMAND messages as well.
    mov     ebx, MAlloc(SIZEOF REQUESTCALLBACK)
    or      ebx, ebx
    jz      @F
    ASSUME  ebx:PTR REQUESTCALLBACK
    mov     [ebx].dwSize, SIZEOF REQUESTCALLBACK
    mmov    [ebx].hLibrary, hPluginID
    mov     [ebx].dwMessage, WM_COMMAND
    mov     [ebx].lpCallback, OFFSET TB_Command
    invoke  PostMessage, NULL, PLUGIN_WINDOWMSG_REQUESTCALLBACK, 0, ebx
    ASSUME  ebx:NOTHING
    @@:
    ret
Init ENDP

; 

Unload PROC USES ebx edi
    xor     eax, eax
    ret
Unload ENDP

; 


; 
; ====================================
; 

GetPluginInfo PROC dwID:DWORD
    mov     eax, dwID
    mov     hPluginID, eax
    IF DEBUG
        PrintHex hPluginID, "toolbar1.dll handle"
    ENDIF

    mov     piPlugin.dwMessages[0], PLUGIN_WINDOWMSG_HWND
    mov     piPlugin.dwMessages[4], PLUGIN_WINDOWMSG_CLICK
    mov     eax, OFFSET piPlugin
    
    ret
GetPluginInfo ENDP

CallFunction PROC dwFuncID:DWORD, lpData:DWORD
    mov     eax, dwFuncID
    .if     (eax==0)
        invoke  Init, lpData
    .elseif (eax==1)
        invoke  Unload
    .else
        
    .endif
    ret
CallFunction ENDP

PluginMessage PROC USES ebx dwMsg:DWORD, lpData:DWORD
    mov     eax, dwMsg
    .if     (eax==PLUGIN_WINDOWMSG_HWND)
        IF DEBUG
            PrintText "PLUGIN_WINDOWMSG_HWND Received"
            PrintHex lpData, "hWnd"
            PrintLine
        ENDIF
        invoke  Init, lpData
    .elseif (eax==PLUGIN_WINDOWMSG_CLICK)
        mov     ebx, lpData
        or      ebx, ebx
        jz      @F
        ;mov     eax, DWORD PTR [ebx]
        ;PrintDec eax, "Mouse X"
        ;mov     eax, DWORD PTR [ebx+4]
        ;PrintDec eax, "Mouse Y"
        MFree   ebx, 8
        @@:
    .endif
    ret
PluginMessage ENDP

end LibMain
