; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
    .nolist
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\dialogs.inc
      include \masm32\include\debug.inc
      include \masm32\macros\macros.asm     ; the macro file
    .list

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\debug.lib

      include ..\common\common.inc
      include ..\common\forms.inc
      
    ; ----------------------------------------
    ; prototypes for local procedures go here
    ; ----------------------------------------

      .data
        szCaption           BYTE        "Main Window",0
        piPlugin            PLUGININFO  <0, STARTUP_AUTOMATIC, OFFSET Init, OFFSET Unload, 16 DUP (0)>
        SizeRestriction     RECT        <0,0,0,0>
        
      .data?
        hPluginID           DWORD       ?
        hInstance           DWORD       ?
        frmMain             DWORD       ?
        frmMainMDI          DWORD       ?
        MyForm              Form        <?>
      .const
        szMDICLIENT         BYTE        "MDICLIENT",0

      .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 
    .if reason == DLL_PROCESS_ATTACH
      push instance
      pop hInstance
      mov eax, TRUE
    .elseif reason == DLL_PROCESS_DETACH
    .elseif reason == DLL_THREAD_ATTACH
    .elseif reason == DLL_THREAD_DETACH
    .endif

    ret
LibMain endp

; 

Init PROC USES ebx edi
    LOCAL   cc:CLIENTCREATESTRUCT
    
    mov     ebx, MAlloc(SIZEOF Form)
    or      ebx, ebx
    jz      EndOfProc
    mov     frmMain, ebx
    ASSUME  ebx:PTR Form
    mov     [ebx].dwLeft, 100
    mov     [ebx].dwTop, 100
    mov     [ebx].dwWidth, 400
    mov     [ebx].dwHeight, 300
    mov     [ebx].lpszCaption, OFFSET szCaption
    invoke  MakeWindowMDI, ebx
    invoke  ShowWindow, [ebx].hWnd, SW_MAXIMIZE
    AddCallback [ebx], WM_LBUTTONUP, OFFSET Form_Click
    AddCallback [ebx], WM_SIZE, OFFSET Form_Resize
    
    ASSUME  ebx:NOTHING
    
        ; Create an MDI client window
    invoke  CreateWindowEx, WS_EX_CLIENTEDGE,
                            OFFSET szMDICLIENT, NULL,
                            WS_CHILD or WS_CLIPCHILDREN or WS_VISIBLE or WS_VSCROLL or WS_HSCROLL,
                            0, 0, 0, 0, DWORD PTR [ebx], NULL, hInstance, ADDR cc
    mov     frmMainMDI, eax
    invoke  SetWindowLong, DWORD PTR [ebx], GWL_USERDATA, eax       ; Store the handle to the MDI client in the window for other plugins
    
    mov     ebx, frmMain
    invoke  PostMessage, NULL, PLUGIN_WINDOWMSG_HWND, 0, DWORD PTR [ebx]
EndOfProc:
    ret
Init ENDP
; 

Unload PROC USES ebx edi
    xor     eax, eax
    inc     eax                 ; Place a non-zero return value for failure
    
    mov     ebx, frmMain
    or      ebx, ebx
    jz      EndOfProc
    invoke  UnloadWindow, ebx
    
    MFree   ebx, SIZEOF Form
    
    xor     eax, eax            ; Zero EAX for success
EndOfProc:
    ret
Unload ENDP

; 

Form_Click:
    mov     ebx, MAlloc(8)
    invoke  GetCursorPos, ebx
    mov     eax, frmMain
    invoke  ScreenToClient, [eax], ebx
    invoke  PostMessage, NULL, PLUGIN_WINDOWMSG_CLICK, 0, ebx
    ret

Form_Resize PROC USES ebx
    LOCAL   winrect:RECT
    mov     ebx, frmMain
    invoke  GetClientRect, DWORD PTR [ebx], ADDR winrect

    mov     eax, winrect.left
    add     eax, SizeRestriction.left
    mov     winrect.left, eax

    mov     eax, winrect.top
    add     eax, SizeRestriction.top
    mov     winrect.top, eax
    
    mov     eax, winrect.right
    sub     eax, SizeRestriction.right
    sub     eax, winrect.left
    mov     winrect.right, eax

    mov     eax, winrect.bottom
    sub     eax, SizeRestriction.bottom
    sub     eax, winrect.top
    mov     winrect.bottom, eax
    
    invoke  MoveWindow, frmMainMDI, winrect.left, winrect.top, winrect.right, winrect.bottom, TRUE
    ret
Form_Resize ENDP

; 
; ====================================
; 

GetPluginInfo PROC dwID:DWORD
    mov     eax, dwID
    mov     hPluginID, eax
    IF DEBUG
        PrintHex hPluginID, "ui1.dll handle"
    ENDIF

    mov     piPlugin.dwMessages[0], PLUGIN_WINDOWMSG_HWND
    mov     piPlugin.dwMessages[4], PLUGIN_WINDOWMSG_REQUESTCALLBACK
    mov     piPlugin.dwMessages[8], PLUGIN_WINDOWMSG_RESTRICTSIZE
    mov     eax, OFFSET piPlugin
    
    ret
GetPluginInfo ENDP

CallFunction PROC dwFuncID:DWORD, lpData:DWORD
    mov     eax, dwFuncID
    .if     (eax==0)
        invoke  Init
    .elseif (eax==1)
        invoke  Unload
    .else
        
    .endif
    ret
CallFunction ENDP

PluginMessage PROC USES ebx dwMsg:DWORD, lpData:DWORD
    mov     eax, dwMsg
    .if     (eax==PLUGIN_WINDOWMSG_REQUESTCALLBACK)
        mov     ebx, lpData
        ASSUME  ebx:PTR REQUESTCALLBACK
        mov     eax, [ebx].dwMessage
        mov     edx, [ebx].lpCallback
        ASSUME  ebx:NOTHING
        push    ebx
        
        mov     ebx, frmMain
        ASSUME  ebx:PTR Form
        AddCallback [ebx], eax, edx
        ASSUME  ebx:NOTHING

        pop     ebx
        MFree   ebx
    .elseif (eax==PLUGIN_WINDOWMSG_RESTRICTSIZE)
        mov     ebx, lpData
        IF DEBUG
            PrintText "PLUGIN_WINDOWMSG_RESTRICTSIZE Memory Dump"
            DumpMem ebx, 16
            PrintLine
        ENDIF

        FOR counter, <0,4,8,12>
            mov     edx, DWORD PTR [ebx+counter]
            or      edx, edx
            jz      @F
            add     DWORD PTR SizeRestriction[counter], edx
            @@:
        ENDM
        
        MFree   ebx
        call    Form_Resize
        
    .endif
    ret
PluginMessage ENDP

end LibMain