; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
    .nolist
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\debug.inc
      include \masm32\macros\macros.asm     ; the macro file
    .list

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\debug.lib


      include ..\common\common.inc
      include ..\common\forms.inc
      
    ; ----------------------------------------
    ; prototypes for local procedures go here
    ; ----------------------------------------
        ChildWndProc        PROTO       :DWORD, :DWORD, :DWORD, :DWORD

      .data
        piPlugin            PLUGININFO  <0, STARTUP_AUTOMATIC, 0, OFFSET Unload, 16 DUP (0)>

        dwChildCount        DWORD       0
        dwUntitledCount     DWORD       0
      .data?
        hPluginID           DWORD       ?
        hInstance           DWORD       ?
        frmMainhWnd         DWORD       ?
        frmChild            DWORD       255 DUP (?)
      .const
        szChildClass        BYTE        "UI2_CHILD_WINDOW",0
        szDefaultCaption    BYTE        "Untitled ",7 DUP (0)     ; [edi+9] is replaced with count

      .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 
    .if reason == DLL_PROCESS_ATTACH
      push instance
      pop hInstance
      mov eax, TRUE
    .elseif reason == DLL_PROCESS_DETACH
    .elseif reason == DLL_THREAD_ATTACH
    .elseif reason == DLL_THREAD_DETACH
    .endif
    ret
LibMain endp

; 

Unload PROC
    LOCAL   dwPreserveEBX:DWORD
    mov     dwPreserveEBX, ebx
    
    mov     ecx, dwChildCount
    or      ecx, ecx
    jz      EndOfProc
    
@@: 
    mov     ebx, frmChild[ecx*4-4]
    push    ecx
    invoke  UnloadWindow, ebx
    MFree   ebx
    pop     ecx
    dec     ecx
    jnz     @B
    
EndOfProc:

    mov     ebx, dwPreserveEBX
    xor     eax, eax
    ret
Unload ENDP

CreateChildWindow PROC USES ebx
    mov     ebx, MAlloc(SIZEOF Form+50)     ;Add 50 bytes for caption
    ASSUME  ebx:PTR Form
    mov     eax, dwChildCount
    imul    eax, eax, 40
    
    mov     [ebx].dwLeft, eax
    mov     [ebx].dwTop, eax
    mov     [ebx].dwWidth, 200
    mov     [ebx].dwHeight, 150
    mov     [ebx].lpszClass, OFFSET szChildClass
    
    lea     edx, [ebx+SIZEOF Form]
    mov     [ebx].lpszCaption, edx
    
    push    edx
    invoke  RtlMoveMemory, edx, OFFSET szDefaultCaption, 16
    pop     edx
    inc     dwUntitledCount
    mov     eax, dwUntitledCount
    
    add     edx, 9
    invoke  dwtoa, dwUntitledCount, edx
    
    ASSUME  ebx:NOTHING
    
    mov     eax, dwChildCount
    inc     dwChildCount
    mov     frmChild[eax*4], ebx
    invoke  GetWindowLong, frmMainhWnd, GWL_USERDATA
    invoke  MakeWindowMDIChild, ebx, eax, OFFSET ChildWndProc
    invoke  ShowWindow, DWORD PTR [ebx], SW_NORMAL
    invoke  PostMessage, NULL, PLUGIN_CHILDMSG_HWND, 0, DWORD PTR [ebx]
    
    mov     eax, DWORD PTR [ebx]
    ret
CreateChildWindow ENDP

; 

ChildWndProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    LOCAL   BMI:BITMAPINFO
    
    .if (uMsg == WM_PAINT)
        invoke  GetWindowLong, hWnd, GWL_USERDATA
        .if (eax != 0)
            mov     ebx, eax
            ASSUME  ebx:PTR OPENCHILDWINDOW
            
            mov     BMI.bmiHeader.biBitCount, 24
            mov     BMI.bmiHeader.biCompression, BI_RGB
            mov     BMI.bmiHeader.biPlanes, 1
            mov     BMI.bmiHeader.biSize, SIZEOF BITMAPINFOHEADER
            
            mov     eax, [ebx].dwWidth
            mov     BMI.bmiHeader.biWidth, eax
            mov     eax, [ebx].dwHeight
            mov     BMI.bmiHeader.biHeight, eax            
            
            invoke  GetDC, hWnd
            mov     edx, eax
            invoke  SetDIBitsToDevice, edx, 0, 0, [ebx].dwWidth, [ebx].dwHeight,
                    0, 0, 0, [ebx].dwHeight, [ebx].lpDIB, ADDR BMI, DIB_RGB_COLORS
            
            ASSUME  ebx:NOTHING
        .endif
    .elseif (uMsg == WM_DESTROY)
        IF DEBUG
            PrintHex hWnd, "Closing child window"
        ENDIF
        invoke  GetWindowLong, hWnd, GWL_USERDATA
        MFree   eax
    .endif
    
    invoke  DefMDIChildProc, hWnd, uMsg, wParam, lParam
    ret
ChildWndProc ENDP

; 

LoadImageData PROC hWnd:DWORD, lpImageData:DWORD
    cmp     hWnd, 0
    je      EndOfProc
    
    PrintHex lpImageData
    mov     eax, DWORD PTR lpImageData.OPENCHILDWINDOW.lpDIB
    invoke  SetWindowLong, hWnd, GWL_USERDATA, eax
    
EndOfProc:
    ret
LoadImageData ENDP

; 
; ====================================
; 

GetPluginInfo PROC dwID:DWORD
    mov     eax, dwID
    mov     hPluginID, eax
    IF DEBUG
        PrintHex hPluginID, "ui2.dll handle"
    ENDIF
    
    mov     piPlugin.dwMessages[0], PLUGIN_WINDOWMSG_HWND
    mov     piPlugin.dwMessages[4], PLUGIN_CHILDMSG_NEW
    mov     eax, OFFSET piPlugin
    
    ret
GetPluginInfo ENDP

CallFunction PROC dwFuncID:DWORD, lpData:DWORD 
    mov     eax, dwFuncID
    .if     (eax==0)
        ;invoke  Init
    .elseif (eax==1)
        invoke  Unload
    .else
        
    .endif
    ret
CallFunction ENDP

PluginMessage PROC dwMsg:DWORD, lpData:DWORD 
    mov     eax, dwMsg
    .if     (eax==PLUGIN_WINDOWMSG_HWND)
        mov     eax, lpData
        mov     frmMainhWnd, eax
    .elseif (eax==PLUGIN_CHILDMSG_NEW)
        .if (frmMainhWnd!=0)
            invoke  CreateChildWindow
            .if (lpData!=0)
                invoke  LoadImageData, eax, lpData
            .endif
        .endif
    .endif
    ret
PluginMessage ENDP

; 

end LibMain
